## hoel 1.4.8

=== CMakeLists.txt ===
#
# Hoel library
#
# CMake file used to build all programs
#
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(hoel C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROJECT_DESCRIPTION "C Database abstraction library with json based language")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/hoel/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")
set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "4")
set(LIBRARY_VERSION_PATCH "8")
set(ORCANIA_VERSION_DOWNLOAD "1.2.9")
set(YDER_VERSION_DOWNLOAD "1.4.4")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
  check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

  if (NOT _GNU_SOURCE)
    unset(_GNU_SOURCE CACHE)
    check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
  endif ()
endif ()

if (_GNU_SOURCE)
  add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
    ${INC_DIR}/hoel.h
    ${INC_DIR}/h-private.h
    ${SRC_DIR}/hoel-simple-json.c
    ${SRC_DIR}/hoel-mariadb.c
    ${SRC_DIR}/hoel-pgsql.c
    ${SRC_DIR}/hoel-sqlite.c
    ${SRC_DIR}/hoel.c)

# dependencies

include(FindJansson)
set(JANSSON_MIN_VERSION 2.4)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
  set(LIBS ${JANSSON_LIBRARIES})
endif ()

option(WITH_SQLITE3 "Use SQLite3 library" ON)

if (WITH_SQLITE3)
  include(FindSQLite3)
  find_package(SQLite3 REQUIRED)
  if (SQLITE3_FOUND)
    set(LIBS ${LIBS} ${SQLITE3_LIBRARIES})
    include_directories(${SQLITE3_INCLUDE_DIR})
    set(LIBS ${LIBS} ${SQLITE3_LIBRARIES})
    set(_HOEL_SQLITE ON)
  else ()
    message("SQLite3 not found")
    set(_HOEL_SQLITE OFF)
  endif ()
else ()
  set(_HOEL_SQLITE OFF)
endif ()

option(WITH_MARIADB "Use MariaDB/MySQL library" ON)

if (WITH_MARIADB)
  include(FindMYSQL)
  find_package(MYSQL REQUIRED)
  if (MYSQL_FOUND)
    set(LIBS ${LIBS} ${MYSQL_LIBRARIES})
    include_directories(${MYSQL_INCLUDE_DIRS})
    set(LIBS ${LIBS} ${MYSQL_LIBRARIES})
    set(_HOEL_MARIADB ON)
  else ()
    message("MariaDB not found")
    set(_HOEL_MARIADB OFF)
  endif ()
else ()
  set(_HOEL_MARIADB OFF)
endif ()

option(WITH_PGSQL "Use PostgreSQL library" ON)

if (WITH_PGSQL)
  include(FindLibPQ)
  find_package(LibPQ REQUIRED)
  if(LIBPQ_FOUND)
    set(LIBS ${LIBS} ${LIBPQ_LIBRARIES})
    include_directories(${LIBPQ_INCLUDE_DIRS})
    set(LIBS ${LIBS} ${LIBPQ_LIBRARIES})
    set(_HOEL_PGSQL ON)
  else ()
    message("LibPQ not found")
    set(_HOEL_PGSQL OFF)
  endif()
else ()
  set(_HOEL_PGSQL OFF)
endif ()

# build hoel-cfg.h file
configure_file(${INC_DIR}/hoel-cfg.h.in ${PROJECT_BINARY_DIR}/hoel-cfg.h)
set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
include_directories(${PROJECT_BINARY_DIR})

if (NOT WITH_PGSQL AND NOT WITH_MARIADB AND NOT WITH_SQLITE3)
  MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB/MySQL or PostgreSQL")
endif ()

set (PKGCONF_REQ "")
set (PKGCONF_REQ_PRIVATE "liborcania, libyder")
if (WITH_SQLITE3)
  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, sqlite3")
endif ()
if (WITH_MARIADB)
  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, mariadb")
endif ()
if (WITH_PGSQL)
  set (PKGCONF_REQ_PRIVATE "${PKGCONF_REQ_PRIVATE}, libpq")
endif ()

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(hoel_static STATIC ${LIB_SRC})
    target_compile_definitions(hoel_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(hoel_static PROPERTIES
            OUTPUT_NAME hoel)
endif ()

# shared library

add_library(hoel SHARED ${LIB_SRC})
set_target_properties(hoel PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER "${INC_DIR}/hoel.h;${PROJECT_BINARY_DIR}/hoel-cfg.h"
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
if (WIN32)
    set_target_properties(hoel PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()
target_link_libraries(hoel ${LIBS})

# dependencies

option(SEARCH_ORCANIA_H "Search for Orcania library" ON)
if (SEARCH_ORCANIA_H)
    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
    include(FindOrcania)
    find_package(Orcania 1.1 QUIET) # try to find orcania
    if (NOT ORCANIA_FOUND)
        include(DownloadProject)
        download_project(PROJ orcania # ... otherwise, download archive
            URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
            QUIET)
        add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
        include_directories(${orcania_SOURCE_DIR}/include)
        add_dependencies(hoel orcania)
        set(ORCANIA_LIBRARIES orcania)
        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
        include_directories(${orcania_BINARY_DIR})
    else()
        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
        include_directories(${ORCANIA_INCLUDE_DIRS})
    endif ()
    target_link_libraries(hoel ${LIBS} ${ORCANIA_LIBRARIES})
endif ()

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during yder search and download

option(SEARCH_YDER "Search for Yder library" ON)
if (SEARCH_YDER)
    set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
    include(FindYder)
    find_package(Yder 1.1 QUIET) # try to find Yder
    if (NOT YDER_FOUND)
        include(DownloadProject)
        download_project(PROJ yder # ... otherwise, download archive
                          URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_DOWNLOAD}.tar.gz"
                          QUIET)
        add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
        include_directories(${yder_SOURCE_DIR}/include)
        add_dependencies(hoel yder)
        set(YDER_LIBRARIES yder orcania)
        include_directories(${yder_BINARY_DIR})
    else()
        set(LIBS ${LIBS} ${YDER_LIBRARIES})
        include_directories(${YDER_INCLUDE_DIRS})
    endif ()
    target_link_libraries(hoel ${LIBS} ${YDER_LIBRARIES})
endif ()

# tests

option(BUILD_HOEL_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)

if (BUILD_HOEL_TESTING)
    include(FindCheck)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS hoel yder orcania ${LIBS} ${CHECK_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)
        endif ()

        set(TESTS core)

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install hoel.h or not

configure_file(libhoel.pc.in libhoel.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libhoel.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

set(TARGETS hoel)
if (BUILD_STATIC)
    set(TARGETS ${TARGETS} hoel_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
    install(DIRECTORY examples/
            DESTINATION ${CMAKE_INSTALL_DOCDIR}/examples/ COMPONENT runtime)
    install(FILES README.md
            DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT runtime)
else ()
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_PACKAGE_NAME "libhoel")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Database abstraction library in C")
set(CPACK_GENERATOR "TGZ;DEB")
set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

option(BUILD_RPM "Build a RPM for your system" OFF)
if (BUILD_RPM)
  set(CPACK_GENERATOR "TGZ;DEB;RPM")
  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/hoel/")
endif ()

set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/hoel")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.14), libjansson4 (>= 2.4), liborcania (>= 1.2), libyder (>= 1.3), zlib1g (>= 1:1.1.4)")

if (WITH_SQLITE3)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsqlite3-0 (>= 3.5.9)")
endif ()

if (WITH_MARIADB)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libmariadbclient18 (>= 5.5.36)")
endif ()

if (WITH_PGSQL)
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libpq5 (>= 9.0~)")
endif ()

set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_h
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

message(STATUS "SQLITE3 library support: ${WITH_SQLITE3}")
message(STATUS "MariaDB library support: ${WITH_MARIADB}")
message(STATUS "PostgreSQL library support: ${WITH_PGSQL}")

=== Makefile ===
#
# Example program
#
# Makefile used to build all programs
#
# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#

LIBHOEL_LOCATION=./src
EXAMPLE_LOCATION=./examples
TEST_LOCATION=./test

all: release

debug:
	cd $(LIBHOEL_LOCATION) && $(MAKE) debug $*

install:
	cd $(EXAMPLE_LOCATION) && $(MAKE) install $*

clean:
	cd $(LIBHOEL_LOCATION) && $(MAKE) clean
	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
	cd $(TEST_LOCATION) && $(MAKE) clean

release:
	cd $(LIBHOEL_LOCATION) && $(MAKE) $*

simple_example:
	cd $(EXAMPLE_LOCATION) && $(MAKE) $*

example_sqlite3:
	cd $(EXAMPLE_LOCATION) && $(MAKE) example_sqlite3 $*

example_mariadb:
	cd $(EXAMPLE_LOCATION) && $(MAKE) example_mariadb $*

example_pgsql:
	cd $(EXAMPLE_LOCATION) && $(MAKE) example_pgsql $*

check:
	cd $(TEST_LOCATION) && $(MAKE) test $*

=== src/Makefile ===
#
# Hoel Framework
#
# Makefile used to build the software
#
# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc

ifndef DISABLE_SQLITE
ENABLE_SQLITE=1
LIBS_SQLITE=-lsqlite3
else
ENABLE_SQLITE=0
endif

ifndef DISABLE_MARIADB
ENABLE_MARIADB=1
FLAGS_MARIADB=$(shell mysql_config --cflags)
LIBS_MARIADB=$(shell mysql_config --libs_r)
else
ENABLE_MARIADB=0
endif

ifndef DISABLE_POSTGRESQL
ENABLE_PGSQL=1
FLAGS_PGSQL=$(shell pkg-config --cflags libpq)
LIBS_PGSQL=$(shell pkg-config --libs libpq)
else
ENABLE_PGSQL=0
endif

HOEL_INCLUDE=../include
DESTDIR=/usr/local
CONFIG_TEMPLATE=$(HOEL_INCLUDE)/hoel-cfg.h.in
CONFIG_FILE=$(HOEL_INCLUDE)/hoel-cfg.h
CFLAGS+=-c -fPIC -Wall -I$(HOEL_INCLUDE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
OBJECTS=hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
OUTPUT=libhoel.so
VERSION=1.4.8

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION)/g' $(CONFIG_FILE)        
	@if [ "$(ENABLE_SQLITE)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine _HOEL_SQLITE/\#define _HOEL_SQLITE/g' $(CONFIG_FILE); \
		echo "SQLITE SUPPORT  ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine _HOEL_SQLITE/\/* #undef _HOEL_SQLITE *\//g' $(CONFIG_FILE); \
		echo "SQLITE SUPPORT  DISABLED"; \
	fi
	@if [ "$(ENABLE_MARIADB)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine _HOEL_MARIADB/\#define _HOEL_MARIADB/g' $(CONFIG_FILE); \
		echo "MARIADB SUPPORT ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine _HOEL_MARIADB/\/* #undef _HOEL_MARIADB *\//g' $(CONFIG_FILE); \
		echo "MARIADB SUPPORT DISABLED"; \
	fi
	@if [ "$(ENABLE_PGSQL)" = "1" ]; then \
		sed -i -e 's/\#cmakedefine _HOEL_PGSQL/\#define _HOEL_PGSQL/g' $(CONFIG_FILE); \
		echo "PGSQL SUPPORT   ENABLED"; \
	else \
		sed -i -e 's/\#cmakedefine _HOEL_PGSQL/\/* #undef _HOEL_PGSQL *\//g' $(CONFIG_FILE); \
		echo "PGSQL SUPPORT   DISABLED"; \
	fi

libhoel.so: $(OBJECTS)
	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) $(OBJECTS) $(LIBS) $(LDFLAGS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

libhoel.a: $(OBJECTS)
	ar rcs libhoel.a $(OBJECTS)

%.o: %.c $(CONFIG_FILE) $(HOEL_INCLUDE)/hoel.h $(HOEL_INCLUDE)/h-private.h
	$(CC) $(CFLAGS) $<

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE)

install: all
	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
	install -m644 $(HOEL_INCLUDE)/hoel.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	/sbin/ldconfig

static-install: static
	cp libhoel.a $(DESTDIR)/lib
	install -m644 $(HOEL_INCLUDE)/hoel.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libhoel.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/hoel.h
	rm -f $(DESTDIR)/include/hoel-cfg.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libhoel.so

release: ADDITIONALFLAGS=-O3

release: libhoel.so

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: libhoel.a

static: ADDITIONALFLAGS=-O3

static: libhoel.a

=== test/Makefile ===
#
# Hoel library
#
# Makefile used to build the tests
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

HOEL_INCLUDE=../include
CC=gcc
CFLAGS=-Wall -I$(HOEL_INCLUDE) -D_REENTRANT -DDEBUG -g -O0
HOEL_LOCATION=../src
LIBS=-lc -lyder -lhoel -ljansson -lcheck -lpthread -lm -lrt -lsubunit -L$(HOEL_LOCATION)

all: test

clean:
	rm -f *.o core valgrind.txt

libhoel.so:
	cd $(HOEL_LOCATION) && $(MAKE) debug

core: core.c
	$(CC) $(CFLAGS) core.c -o core $(LIBS)

test_core: libhoel.so core
	-LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./core

test: test_core

=== debian/changelog ===
hoel (1.4.8-4) unstable; urgency=medium

  * debian/tests/control: fix autopkgtest dependencies
  * debian/rules: clarify dh_auto_configure to explicitly declare options
                  build tests from cmake instead of Makefile
  * debian/control: update Standards-Version to 4.3.0 (no change)

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 05 Jan 2019 10:40:01 -0500

hoel (1.4.8-3) unstable; urgency=medium

  * debian/control: replace libmariadbclient-dev with default-libmysqlclient-dev
    (Closes: #917763)

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 30 Dec 2018 08:26:01 -0500

hoel (1.4.8-2) unstable; urgency=medium

  * debian/*install: Add pkg-config file
  * debian/*install: multiarchify files

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 16 Dec 2018 14:16:39 -0500

hoel (1.4.8-1) unstable; urgency=medium

  * New upstream release
  * Add autopkgtests suite
  * Add unit tests

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 15 Dec 2018 12:51:30 -0500

=== debian/control ===
Source: hoel
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
          , Nicolas Mora <nicolas@babelouest.org>
Build-Depends: debhelper (>= 11)
             , autopkgtest (>= 5.6~)
             , dh-exec
             , liborcania-dev
             , libyder-dev
             , libjansson-dev
             , libsqlite3-dev
             , libpq-dev
             , default-libmysqlclient-dev
             , cmake
             , pkg-config
             , check
             , sqlite3
Standards-Version: 4.3.0
Homepage: https://github.com/babelouest/hoel
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git

Package: libhoel1.4
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: database abstraction library written in C
 Simple and easy to use database access library. Works with SQLite 3,
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
 language with jansson to execute simples queries based on one table.

Package: libhoel-dev
Architecture: any
Section: libdevel
Depends: libhoel1.4 (= ${binary:Version})
       , ${misc:Depends}
       , libjansson-dev
       , liborcania-dev
       , libyder-dev
       , libsqlite3-dev
       , libpq-dev
       , default-libmysqlclient-dev
Description: database abstraction library written in C - development
 Simple and easy to use database access library. Works with SQLite 3,
 MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
 language with jansson to execute simples queries based on one table.
 .
 This package contains the development files.

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, check, sqlite3

## hoel 1.4.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # CMake file used to build all programs
 #
-# Copyright 2018 Nicolas Mora <mail@babelouest.org>
+# Copyright 2018-2020 Nicolas Mora <mail@babelouest.org>
 # Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
 #
 # This program is free software; you can redistribute it and/or
@@ -28,11 +28,33 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "8")
-set(ORCANIA_VERSION_DOWNLOAD "1.2.9")
-set(YDER_VERSION_DOWNLOAD "1.4.4")
+set(LIBRARY_VERSION_PATCH "16")
+set(ORCANIA_VERSION_REQUIRED "2.0.1")
+set(YDER_VERSION_REQUIRED "1.4.10")
+set(JANSSON_VERSION_REQUIRED "2.4")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
+set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
+set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
+set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
+
+if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
+    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
+else ()
+    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
+endif ()
+if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
+    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
+else ()
+    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
+endif ()
+if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
+    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
+else ()
+    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
+endif ()
+set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")
+
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
 
@@ -75,6 +97,10 @@
     ${SRC_DIR}/hoel.c)
 
 # dependencies
+
+# pthread libraries
+find_package (Threads)
+set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
 
 include(FindJansson)
 set(JANSSON_MIN_VERSION 2.4)
@@ -182,24 +208,52 @@
 endif ()
 target_link_libraries(hoel ${LIBS})
 
+# documentation
+
+option(BUILD_HOEL_DOCUMENTATION "Build the documentation." OFF)
+if (BUILD_HOEL_DOCUMENTATION)
+    find_package(Doxygen)
+    if (DOXYGEN_FOUND)
+        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
+        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
+        
+        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
+        
+        add_custom_target(doc
+                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
+                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+                          COMMENT "Generating documentation with Doxygen"
+                          VERBATIM)
+
+    else ()
+        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
+    endif ()
+endif ()
+
 # dependencies
+
+option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)
 
 option(SEARCH_ORCANIA_H "Search for Orcania library" ON)
 if (SEARCH_ORCANIA_H)
     set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
     include(FindOrcania)
-    find_package(Orcania 1.1 QUIET) # try to find orcania
+    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
     if (NOT ORCANIA_FOUND)
-        include(DownloadProject)
-        download_project(PROJ orcania # ... otherwise, download archive
-            URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_DOWNLOAD}.tar.gz"
-            QUIET)
-        add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
-        include_directories(${orcania_SOURCE_DIR}/include)
-        add_dependencies(hoel orcania)
-        set(ORCANIA_LIBRARIES orcania)
-        set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
-        include_directories(${orcania_BINARY_DIR})
+        if (DOWNLOAD_DEPENDENCIES)
+            include(DownloadProject)
+            download_project(PROJ orcania # ... otherwise, download archive
+                URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
+                QUIET)
+            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
+            include_directories(${orcania_SOURCE_DIR}/include)
+            add_dependencies(hoel orcania)
+            set(ORCANIA_LIBRARIES orcania)
+            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+            include_directories(${orcania_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Orcania not found")
+        endif ()
     else()
         set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
         include_directories(${ORCANIA_INCLUDE_DIRS})
@@ -215,15 +269,19 @@
     include(FindYder)
     find_package(Yder 1.1 QUIET) # try to find Yder
     if (NOT YDER_FOUND)
-        include(DownloadProject)
-        download_project(PROJ yder # ... otherwise, download archive
-                          URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_DOWNLOAD}.tar.gz"
-                          QUIET)
-        add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
-        include_directories(${yder_SOURCE_DIR}/include)
-        add_dependencies(hoel yder)
-        set(YDER_LIBRARIES yder orcania)
-        include_directories(${yder_BINARY_DIR})
+        if (DOWNLOAD_DEPENDENCIES)
+            include(DownloadProject)
+            download_project(PROJ yder # ... otherwise, download archive
+                              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
+                              QUIET)
+            add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
+            include_directories(${yder_SOURCE_DIR}/include)
+            add_dependencies(hoel yder)
+            set(YDER_LIBRARIES yder orcania)
+            include_directories(${yder_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Yder not found")
+        endif ()
     else()
         set(LIBS ${LIBS} ${YDER_LIBRARIES})
         include_directories(${YDER_INCLUDE_DIRS})
@@ -323,56 +381,3 @@
 
 if (INSTALL_HEADER)
     set(PACKAGE_FILE_NAME
-            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
-else ()
-    set(PACKAGE_FILE_NAME
-            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
-endif ()
-set(PACKAGE_IGNORED_FILES
-        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")
-
-set(CPACK_PACKAGE_NAME "libhoel")
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Database abstraction library in C")
-set(CPACK_GENERATOR "TGZ;DEB")
-set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
-set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
-set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
-
-option(BUILD_RPM "Build a RPM for your system" OFF)
-if (BUILD_RPM)
-  set(CPACK_GENERATOR "TGZ;DEB;RPM")
-  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
-  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/hoel/")
-endif ()
-
-set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
-set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
-set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/hoel")
-set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.14), libjansson4 (>= 2.4), liborcania (>= 1.2), libyder (>= 1.3), zlib1g (>= 1:1.1.4)")
-
-if (WITH_SQLITE3)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libsqlite3-0 (>= 3.5.9)")
-endif ()
-
-if (WITH_MARIADB)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libmariadbclient18 (>= 5.5.36)")
-endif ()
-
-if (WITH_PGSQL)
-  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libpq5 (>= 9.0~)")
-endif ()
-
-set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
-
-set(CPACK_SOURCE_GENERATOR "TGZ")
-set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
-set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})
-
-include(CPack)
-
-add_custom_target(dist_h
-        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
-
-message(STATUS "SQLITE3 library support: ${WITH_SQLITE3}")
-message(STATUS "MariaDB library support: ${WITH_MARIADB}")
-message(STATUS "PostgreSQL library support: ${WITH_PGSQL}")

=== src/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # Makefile used to build the software
 #
-# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
+# Copyright 2014-2020 Nicolas Mora <mail@babelouest.org>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public License
@@ -43,22 +43,35 @@
 ENABLE_PGSQL=0
 endif
 
+PROJECT_NAME=hoel
+PROJECT_DESCRIPTION=C Database abstraction library with json based language
+PROJECT_BUGREPORT_PATH=https://github.com/babelouest/hoel/issues
+PKGCONF_REQ=
+PKGCONF_REQ_PRIVATE=
 HOEL_INCLUDE=../include
 DESTDIR=/usr/local
 CONFIG_TEMPLATE=$(HOEL_INCLUDE)/hoel-cfg.h.in
 CONFIG_FILE=$(HOEL_INCLUDE)/hoel-cfg.h
-CFLAGS+=-c -fPIC -Wall -I$(HOEL_INCLUDE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
+PKGCONFIG_FILE=../libhoel.pc
+PKGCONFIG_TEMPLATE=../libhoel.pc.in
+CFLAGS+=-c -fPIC -Wall -Werror -Wextra -I$(HOEL_INCLUDE) $(FLAGS_MARIADB) $(FLAGS_PGSQL) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
 LIBS=-L$(DESTDIR)/lib -lc -ljansson -lyder -lorcania $(LIBS_SQLITE) $(LIBS_PGSQL) $(LIBS_MARIADB)
 OBJECTS=hoel-sqlite.o hoel-mariadb.o hoel-pgsql.o hoel-simple-json.o hoel.o
 OUTPUT=libhoel.so
-VERSION=1.4.8
+VERSION_MAJOR=1
+VERSION_MINOR=4
+VERSION_PATCH=16
 
 all: release
 
 $(CONFIG_FILE):
 	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
 	@echo Config file $(CONFIG_FILE) generated
-	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION)/g' $(CONFIG_FILE)        
+	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
+	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
+	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
+	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
+	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        
 	@if [ "$(ENABLE_SQLITE)" = "1" ]; then \
 		sed -i -e 's/\#cmakedefine _HOEL_SQLITE/\#define _HOEL_SQLITE/g' $(CONFIG_FILE); \
 		echo "SQLITE SUPPORT  ENABLED"; \
@@ -81,9 +94,22 @@
 		echo "PGSQL SUPPORT   DISABLED"; \
 	fi
 
+$(PKGCONFIG_FILE):
+	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
+	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
+	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@CMAKE_INSTALL_LIBDIR@/lib/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@CMAKE_INSTALL_INCLUDEDIR@/include/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
+	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)
+
 libhoel.so: $(OBJECTS)
-	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) $(OBJECTS) $(LIBS) $(LDFLAGS)
-	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
+	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LDFLAGS)
+	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)
 
 libhoel.a: $(OBJECTS)
 	ar rcs libhoel.a $(OBJECTS)
@@ -92,16 +118,19 @@
 	$(CC) $(CFLAGS) $<
 
 clean:
-	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE)
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE)
 
-install: all
-	cp $(OUTPUT).$(VERSION) $(DESTDIR)/lib
+install: all $(PKGCONFIG_FILE)
+	cp $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
+	mkdir -p $(DESTDIR)/lib/pkgconfig/
+	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
 	install -m644 $(HOEL_INCLUDE)/hoel.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
-	/sbin/ldconfig
+	-ldconfig $(DESTDIR)/lib
 
 static-install: static
 	cp libhoel.a $(DESTDIR)/lib
+	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig
 	install -m644 $(HOEL_INCLUDE)/hoel.h $(DESTDIR)/include
 	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
 
@@ -109,7 +138,8 @@
 	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libhoel.a
 	rm -f $(DESTDIR)/lib/$(OUTPUT).*
 	rm -f $(DESTDIR)/include/hoel.h
-	rm -f $(DESTDIR)/include/hoel-cfg.h
+	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
+	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)
 
 debug: ADDITIONALFLAGS=-DDEBUG -g -O0

=== debian/changelog ===
hoel (1.4.16-3) unstable; urgency=medium

  * d/tests/control: add missing dependencies
  * d/tests/unit-test: fix unit-test

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 09:37:49 -0400

hoel (1.4.16-2) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 27 Jun 2020 17:53:55 -0400

hoel (1.4.16-1) experimental; urgency=medium

  * New upstream release
  * d/rules: generate doc using doxygen
  * d/libhoel-dev.docs: install documentation
  * d/patches: Fix doxygen privacy issues
  * d/control: replace debhelper with debhelper-compat
  * d/control: set compat version to 13
  * d/control: add Rules-Requires-Root: no

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 04 Jun 2020 07:36:32 -0400

hoel (1.4.15-1) experimental; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.5.0 (no changes)
  * debian/copyright: fix copyright issues
  * debian/upstream: add metadata file

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 31 Mar 2020 21:53:14 -0400

hoel (1.4.8-5) unstable; urgency=medium

  * debian/control: Add Multi-Arch: same
  * Fix shlibs warning on pthread

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 08 Jan 2019 20:28:02 -0500

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
           , Nicolas Mora <nicolas@babelouest.org>
-Build-Depends: debhelper (>= 11)
+Build-Depends: debhelper-compat (= 13)
              , autopkgtest (>= 5.6~)
              , dh-exec
              , liborcania-dev
@@ -17,13 +17,16 @@
              , pkg-config
              , check
              , sqlite3
-Standards-Version: 4.3.0
+             , doxygen
+Standards-Version: 4.5.0
 Homepage: https://github.com/babelouest/hoel
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
+Rules-Requires-Root: no
 
 Package: libhoel1.4
 Architecture: any
+Multi-Arch: same
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -34,6 +37,7 @@
 
 Package: libhoel-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: libhoel1.4 (= ${binary:Version})
        , ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) \
	                    -DWITH_SQLITE3=ON \
	                    -DWITH_MARIADB=ON \
	                    -DWITH_PGSQL=ON \
	                    -DBUILD_HOEL_TESTING=ON \
	                    -DINSTALL_HEADER=ON \
	                    --no-warn-unused-cli

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	sqlite3 /tmp/test.db < test/test.sqlite3.sql
	dh_auto_test
endif

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	dh_auto_build --

## hoel 1.4.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,9 +28,9 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/hoel/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "4")
-set(LIBRARY_VERSION_PATCH "16")
+set(LIBRARY_VERSION_PATCH "17")
 set(ORCANIA_VERSION_REQUIRED "2.0.1")
-set(YDER_VERSION_REQUIRED "1.4.10")
+set(YDER_VERSION_REQUIRED "1.4.12")
 set(JANSSON_VERSION_REQUIRED "2.4")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
@@ -127,7 +127,7 @@
   set(_HOEL_SQLITE OFF)
 endif ()
 
-option(WITH_MARIADB "Use MariaDB/MySQL library" ON)
+option(WITH_MARIADB "Use MariaDB library" ON)
 
 if (WITH_MARIADB)
   include(FindMYSQL)
@@ -169,7 +169,7 @@
 include_directories(${PROJECT_BINARY_DIR})
 
 if (NOT WITH_PGSQL AND NOT WITH_MARIADB AND NOT WITH_SQLITE3)
-  MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB/MySQL or PostgreSQL")
+  MESSAGE(FATAL_ERROR "You must enable at least one databasse backend: Sqlite3, MariaDB or PostgreSQL")
 endif ()
 
 set (PKGCONF_REQ "")

=== src/Makefile ===
--- 
+++ 
@@ -60,7 +60,7 @@
 OUTPUT=libhoel.so
 VERSION_MAJOR=1
 VERSION_MINOR=4
-VERSION_PATCH=16
+VERSION_PATCH=17
 
 all: release

=== test/Makefile ===
#
# Hoel library
#
# Makefile used to build the tests
#
# Public domain, no copyright. Use at your own risk
#

HOEL_INCLUDE=../include
CC=gcc
CFLAGS=-Wall -I$(HOEL_INCLUDE) -D_REENTRANT -DDEBUG -g -O0
HOEL_LOCATION=../src
LIBS=-lc -lyder -lhoel -ljansson -lcheck -lpthread -lm -lrt -lsubunit -L$(HOEL_LOCATION)

all: test

clean:
	rm -f *.o core multi valgrind.txt

libhoel.so:
	cd $(HOEL_LOCATION) && $(MAKE) debug

core: core.c
	$(CC) $(CFLAGS) core.c -o core $(LIBS)

test_core: libhoel.so core
	-LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./core

multi: multi.c
	$(CC) $(CFLAGS) multi.c -o multi $(LIBS)

test_multi: libhoel.so multi
	-LD_LIBRARY_PATH=$(HOEL_LOCATION):${LD_LIBRARY_PATH} ./multi

test: test_core

=== debian/changelog ===
hoel (1.4.17-2) unstable; urgency=medium

  * Update package description (Closes: #983693)
  * d/copyright: update licenses

 -- Nicolas Mora <babelouest@debian.org>  Sun, 28 Feb 2021 14:07:53 -0500

hoel (1.4.17-1) unstable; urgency=medium

  * New upstream release
  * d/rules: avoid downloading dependencies if not found
  * d/control: Remove dh-exec from builddep
  * d/control: Update Standards-Version to 4.5.1

 -- Nicolas Mora <babelouest@debian.org>  Sun, 13 Dec 2020 10:51:43 -0500

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,9 @@
 Priority: optional
 Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
-          , Nicolas Mora <nicolas@babelouest.org>
+          , Nicolas Mora <babelouest@debian.org>
 Build-Depends: debhelper-compat (= 13)
              , autopkgtest (>= 5.6~)
-             , dh-exec
              , liborcania-dev
              , libyder-dev
              , libjansson-dev
@@ -18,7 +17,7 @@
              , check
              , sqlite3
              , doxygen
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/babelouest/hoel
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/hoel.git
@@ -32,7 +31,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: database abstraction library written in C
  Simple and easy to use database access library. Works with SQLite 3,
- MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
+ MariaDB/Mysql and PostgreSQL databases. Uses a json-based
  language with jansson to execute simples queries based on one table.
 
 Package: libhoel-dev
@@ -49,7 +48,7 @@
        , default-libmysqlclient-dev
 Description: database abstraction library written in C - development
  Simple and easy to use database access library. Works with SQLite 3,
- MariaDB/Mysql and (barely) PostgreSQL databases. Uses a json-based
+ MariaDB/Mysql and PostgreSQL databases. Uses a json-based
  language with jansson to execute simples queries based on one table.
  .
  This package contains the development files.

=== debian/rules ===
--- 
+++ 
@@ -20,12 +20,13 @@
 	                    -DWITH_PGSQL=ON \
 	                    -DBUILD_HOEL_TESTING=ON \
 	                    -DINSTALL_HEADER=ON \
+	                    -DDOWNLOAD_DEPENDENCIES=OFF \
 	                    --no-warn-unused-cli
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
 	sqlite3 /tmp/test.db < test/test.sqlite3.sql
-	dh_auto_test
+	dh_auto_test --
 endif
 
 override_dh_auto_build:
